autowatch = 1;

inlets = 1;
outlets = 2;

var fIDArray = new Array(); // array holding Finger ID

var avArray = new Array(); // array holding available voices

var maxVoices = 10;

post("instantiating voices","\n");
for(var i = 0; i < maxVoices; i++){
fIDArray[i] = 9999;
avArray[i] = i;
}

function fingerID(fID,fState,x,y){
// post(fID,fState,x,y,"\n");
var yFlip = 1 - y;
var fIndex = fIDArray.indexOf(fID);// does this finger exist?
if(fIndex == -1){// assign a voice
	var ix = 0;
	if(avArray.length && fState != 3){// there are some available slots
		// return an index based on available slots
		ix = Math.floor(Math.random() * avArray.length);
		// return and remove the value in that index
		ix = Number(avArray.splice(ix,1));// number conversion as string returned
		fIDArray[ix] = fID;
		// post("assigning voice",ix,"to fID",fID,"\n");
		// nb fState gives a 1 on first touch
		// post(ix, 2, "\n");
		outlet(1,(ix + 1),2,x,yFlip);
		}
	else if(fState == 3) post("is a release without an index","\n");
	else post("no voices left","\n");
	}
else {
	// post(fIndex, fState, "\n");
	outlet(1,fIndex + 1,fState,x,yFlip);
	// now to deal with reallocation
	if(fState == 3){// finger was released
		// post("freeing voice",fIndex,"from fID",fID,"\n");
		fIDArray[fIndex] = 9999;
		avArray.push(fIndex);
		}
	}
}

function resetVoices(){
	for(var i = 0; i < maxVoices; i++){
	fIDArray[i] = 9999;
	avArray[i] = i;
	outlet(1,(i + 1),3,0,0);
	}
}
